import pyddl
import os
import sys
import numpy as np

n = 100

pyddl.init(os.environ['DDL_OPTIONS'])

initial_values = [x for x in range(n)]

arr = np.array(initial_values, dtype=np.float32)

res, buf = pyddl.malloc(64, n * 4)

pyddl.memcpy_host_to_device(buf, arr)

pyddl.memsync()

res, event = pyddl.allreduce_async(buf, n, pyddl.DDL_TYPE_FLOAT, pyddl.DDL_OP_SUM)

pyddl.wait(event)

pyddl.memcpy_device_to_host(arr, buf)

pyddl.memsync()

pyddl.free(buf)

# Verify that the allreduce produced the correct result
result = np.array_equal(pyddl.size() * np.array(initial_values, dtype=np.float32), arr)

pyddl.finalize()

if result:
    sys.exit(0)
else:
    sys.exit(1)

